/* Gnome-Streamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#include "gstjpegdec.h"
#include "gstjpegenc.h"

//#define debug(format,args...) g_print(format,##args)
#define debug(format,args...)

/* elementfactory information */
extern GstElementDetails gst_jpegdec_details;
extern GstElementDetails gst_jpegenc_details;

GstTypeFactory jpegfactory = {
  "image/jpeg",
  ".jpeg .jpg",
  NULL,
};

GstPlugin *plugin_init(GModule *module) {
  GstPlugin *plugin;
  GstElementFactory *dec, *enc;

  plugin = gst_plugin_new("jpeg");
  g_return_val_if_fail(plugin != NULL, NULL);

  /* create an elementfactory for the jpegdec element */
  enc = gst_elementfactory_new("jpegenc",GST_TYPE_JPEGENC,
                                   &gst_jpegenc_details);
  g_return_val_if_fail(enc != NULL, NULL); 
  gst_plugin_add_factory(plugin,enc);

  /* create an elementfactory for the jpegdec element */
  dec = gst_elementfactory_new("jpegdec",GST_TYPE_JPEGDEC,
                                   &gst_jpegdec_details);
  g_return_val_if_fail(dec != NULL, NULL); 
  gst_plugin_add_factory(plugin,dec);

  return plugin;
}
